﻿//
import SD.RD;
import SGF.GamePiece;
import  SH.Game.General;
import mx.events.EventDispatcher;
import mx.transitions.Tween;
import mx.transitions.easing.*;
//Can extend GamePiece or GameCollisionPiece
class GamePlay3.Round1QuestionsMC extends GamePiece{		

//************************************************************
//PRIVATE VARS
//************************************************************

//Private vars
private var __questionArray:Array;
private var __questionNo:Number;
private var __myGeneral:General;

//Sub MC Vars
private var txtQuestionsRound1:MovieClip;
private var txtAnswersRound1:MovieClip;

//Sub MC Buttons
//private var b:Button;

//Sub TextField vars
//private var t:TextField;

//Components

//************************************************************
//PUBLIC VARS
//************************************************************

//Public vars

//************************************************************
//CONSTRUCTOR FUNCTIONS
//************************************************************

 function Round1QuestionsMC(){

	//RD.D("GameController Created", this);
	//__linkageName = "MC";
	makeThisADispatcher();
	//dispatchMyEvent("e_someEvent", {myMessage:"none"});
	__myGeneral = new General();
	__questionArray = [{qNum:1, qAns:"deny"}, {qNum:2, qAns:"deny"}, {qNum:3, qAns:"accept"}, {qNum:4, qAns:"deny"}, {qNum:5, qAns:"accept"}, {qNum:6, qAns:"deny"}];
	
	addEventListener("e_UserLooses", this._parent);
	addEventListener("e_UserNextRound", this._parent);
	addEventListener("e_updateScores", this._parent);
	
	//setupBtns();

}

//private function setupBtns(){}

//************************************************************
//PROPERTIES
//************************************************************

//************************************************************
//INITIAL FUNCTIONS: Usually functions off the constructor
//************************************************************
//this overides the scene director function which is called when a new scene containing this MC is loaded
/*private function playScene(){}*/

//this is called when the scene that this GamePiece is in is removed
//Note when you call this you have to handle the removal of the GamePiece yourself
/*private function removeScene(){}*/

//using this function overrides the general hide scene hideGamePiece() function
//so make sure you hide the GamePiece after running this function
/*private function removeScene(){}*/

/*private function initiate(){}*/

//************************************************************
//PUBLIC VISUAL FUNCTIONS: Functions that hide and show items in the MC
//************************************************************

/*public function v_function(){}*/

//************************************************************
//PRIVATE VISUAL FUNCTIONS: Functions that hide and show items in the MC
//************************************************************

//************************************************************
//PUBLIC VISUAL STRUCTURAL FUNCTIONS: Functions that affect the visuals and structure of the MC
//************************************************************

public function enable(){}

public function disable(){}




	public function disableAcceptDeny(){
	
		txtQuestionsRound1.a.enabled = false;
		txtQuestionsRound1.d.enabled = false;
		
	}

	
	public function enableAcceptDeny(){
	
		txtQuestionsRound1.a.enabled = true;
		txtQuestionsRound1.d.enabled = true;
		
	}
	
	
	public function disableContinue(){
	
		txtAnswersRound1.c.enabled = false;
		
	}

	
	public function enableContinue(){
	
		txtAnswersRound1.c.enabled = true;
		
	}

public function v_hide(){

	_visible = false;

}

public function v_show(){

	_visible = true;

}


public function v_start(){
	
	getRef().ScoreRound1 = 0;
	__questionNo = 0;
	__questionArray = __myGeneral.scrambleArray(__questionArray);
	_visible = true;
	_alpha = 0;
	txtAnswersRound1._visible = false;
	
	var myTween:Object = new Tween(this, "_alpha", Regular.easeOut, 0, 100, .5, true);
	
	txtAnswersRound1._visible = false;
	
	txtQuestionsRound1.a.v_reset();
	txtQuestionsRound1.d.v_reset();
		
	v_askQuestion();

}

//************************************************************
//PRIVATE VISUAL STRUCTURAL FUNCTIONS: Functions that affect the visuals and structure of the MC
//************************************************************
private function v_askQuestion(){
	
	//getRef().gameSounds.playSound("question");
	_level0.jdgSoundHandMC.fadeSounds('out');
	
	txtAnswersRound1._visible = false;
	txtQuestionsRound1.gotoAndStop("q" + __questionArray[__questionNo].qNum);
	enableAcceptDeny();
	
	txtQuestionsRound1.a.v_reset();
	txtQuestionsRound1.d.v_reset();
	
	txtQuestionsRound1._visible = true;
	var myTween:Object = new Tween(this, "_alpha", Regular.easeOut, 0, 100, .5, true);
	
}

private function v_showAnswer(userResponse:String){
	
	enableContinue()
	disableAcceptDeny();
	txtAnswersRound1._visible = true;
	
	//update score
	if(__questionArray[__questionNo].qAns == userResponse){
		
		//User got it right
		getRef().gameSounds.playSound("correct");
		trace("CORRECT");
		getRef().ScoreRound1++;
		
	}else{
		
		getRef().gameSounds.playSound("incorrect");
		
	}
	
	if(userResponse == "accept"){
		
		
		txtAnswersRound1.gotoAndStop("a" + __questionArray[__questionNo].qNum + "-y");
		
	}else{
		
		
		txtAnswersRound1.gotoAndStop("a" + __questionArray[__questionNo].qNum + "-n");
		
	}
	
//	dispatchMyEvent("e_updateScores", {questionCount:__questionNo});
	
	__questionNo++;
	
}

//************************************************************
//PUBLIC CHARACTER FUNCTIONS: Functions that animate characters
//************************************************************

//************************************************************
//PUBLIC CHARACTER SCRIPT FUNCTIONS: Functions called from outside which execute character animation scripts
//************************************************************

//************************************************************
//PUBLIC GENERAL FUNCTIONS
//************************************************************

//************************************************************
//PRIVATE GENERAL FUNCTIONS
//************************************************************

//************************************************************
//PRIVATE HELPER FUNCTIONS
//************************************************************

//____EVENTS_________________________________________________

//************************************************************
//REGULAR EVENT FUNCTIONS: Functions that fire off regular MC events like private function onRelease(){}
//************************************************************

//************************************************************
//CUSTOM EVENT FUNCTIONS: Functions that fire off custom made dispatched events
//************************************************************

//************************************************************
//CUSTOM LOCAL EVENT FUNCTIONS: Functions that fire off events written into the fla of a MC like  _parent.e_fireMyFunction();
//************************************************************

	private function e_accept(){
		
		//trace("ACCEPT");
		v_showAnswer("accept");
		
	}
	
	private function e_deny(){
		
		//trace("DENY");
		v_showAnswer("deny");
		
	}
	
	private function e_continue(){
		
		disableContinue();
		
		
		//pause code
		var myFunc = function(callingMC:MovieClip){
				
			var myTween:Object = new Tween(callingMC, "_alpha", Regular.easeOut, 100, 0, .5, true);
									
		};
						
		pauseCodeAndCallFunction(1, myFunc);

		dispatchMyEvent("e_updateScores", {questionCount:__questionNo-1});

		
		if(__questionNo != 6){
		
			_level0.jdgSoundHandMC.fadeSounds('in');
			
			//pause code
			var myFunc = function(callingMC:MovieClip){
									
				callingMC.v_askQuestion();
									
			};
						
			pauseCodeAndCallFunction(2, myFunc);
			
		}else{
					
			if(getRef().ScoreRound1 >= 2){
				//player goes to next round
				//pause code
				var myFunc = function(callingMC:MovieClip){
									
					callingMC.dispatchMyEvent("e_UserNextRound", {myMessage:"none"});
									
				};
						
				pauseCodeAndCallFunction(2, myFunc);
				
				
			}else{
				//player is returned to start
				var myFunc = function(callingMC:MovieClip){
									
					callingMC.dispatchMyEvent("e_UserLooses", {myMessage:"none"});
									
				};
						
				pauseCodeAndCallFunction(2, myFunc);
				
				
			}
		}
	}

//************************************************************
//SUB MCs THAT FIRE FUNCTIONS: Functions that are called from .as files child MovieClips
//************************************************************

}
