﻿//
import SD.RD;
import SGF.GamePiece;
import  SH.Game.General;
import mx.transitions.Tween;
import mx.transitions.easing.*;

//Can extend GamePiece or GameCollisionPiece
class GamePlay5.Round2QuestionsMC extends GamePiece{
	
	//************************************************************
	//PRIVATE VARS
	//************************************************************
	
	//Private vars
	private var __questionArray:Array;
	private var __questionNo:Number;
	private var __myGeneral:General;
	
	//private var s:String;
	
	//Sub MC Vars
	
	//private var m:MovieClip;
	private var txtQuestionsRound2:MovieClip;
	private var txtAnswersRound2:MovieClip;
	
	//Sub MC Buttons
	
	//private var b:Button;
	
	//Sub TextField vars
	
	//private var t:TextField;
	
	
	//Components
	
	
	
	
	//************************************************************
	//PUBLIC VARS
	//************************************************************
	
	//Public vars
	
	
	
	
	//************************************************************
	//CONSTRUCTOR FUNCTIONS
	//************************************************************

	public function Round2QuestionsMC(){
		
		//RD.D("GameController Created", this);
		//__linkageName = "GameControllerMC";
		makeThisADispatcher();
		//dispatchMyEvent("e_someEvent", {myMessage:"none"});
		__myGeneral = new General();
		__questionArray = [{qNum:1, qAns:"true"}, {qNum:2, qAns:"false"}, {qNum:3, qAns:"true"}];
		
		addEventListener("e_TFQuestionsFinished", this._parent);
		addEventListener("e_UserLooses", this._parent);
		addEventListener("e_updateScores", this._parent);
		
		setupBtns();
		
	}
	
	
	private function setupBtns(){
		
		
		
	}
		
		
		
		
	//************************************************************
	//PROPERTIES
	//************************************************************
	
	
	
	//************************************************************
	//INITIAL FUNCTIONS: Usually functions off the constructor
	//************************************************************
	//this overides the scene director function which is called when a new scene containing this MC is loaded
	//private function playScene(){
		
		
	//}
	
	//this is called when the scene that this GamePiece is in is removed
	//Note when you call this you have to handle the removal of the GamePiece yourself
	//private function removeScene(){
		
		
	//}
	
	
	//using this function overrides the general hide scene hideGamePiece() function
	//so make sure you hide the GamePiece after running this function
	/*private function removeScene(){
		
		
	}*/
	
	
	private function initiate(){
		
		
	}
	
	//************************************************************
	//PUBLIC VISUAL FUNCTIONS: Functions that hide and show items in the MC
	//************************************************************
	
	public function v_start(){
		
		trace("START QUESTIONS");
		__questionNo = 0;
		getRef().ScoreMissesRound2 = 0;
		__questionArray = __myGeneral.scrambleArray(__questionArray);
		_visible = true;
		_alpha = 0;
		
		txtQuestionsRound2.t.v_reset();
		txtQuestionsRound2.f.v_reset();
		
		 v_askQuestion();
		
	}
	
	
	//************************************************************
	//PRIVATE VISUAL FUNCTIONS: Functions that hide and show items in the MC
	//************************************************************
	
	private function v_askQuestion(){
		
		_level0.jdgSoundHandMC.fadeSounds('out');
//		getRef().gameSounds.playSound("question");
		
		txtAnswersRound2._visible = false;
		var myTween:Object = new Tween(this, "_alpha", Regular.easeOut, 0, 100, .5, true);
		
		txtQuestionsRound2.gotoAndStop("q" + __questionArray[__questionNo].qNum);
		enableAcceptDeny();
		txtQuestionsRound2.t.v_reset();
		txtQuestionsRound2.f.v_reset();
		txtQuestionsRound2._visible = true;
	
	}
	
	
	private function v_showAnswer(userResponse:String){
	
	enableContinue()
	disableAcceptDeny();
	txtAnswersRound2._visible = true;
	
	//update score
	if(__questionArray[__questionNo].qAns != userResponse){
		
		//User got it wrong
		getRef().gameSounds.playSound("incorrect");
		getRef().ScoreMissesRound2++;
		
	}else{
		
		getRef().gameSounds.playSound("correct");
		
	}
	
	
	if(userResponse == "true"){
		
		
		txtAnswersRound2.gotoAndStop("a" + __questionArray[__questionNo].qNum + "-t");
		
	}else{
		
		
		txtAnswersRound2.gotoAndStop("a" + __questionArray[__questionNo].qNum + "-f");
		
	}

	dispatchMyEvent("e_updateScores", {questionCount:__questionNo});
	
	__questionNo++;
	
}
	
	//************************************************************
	//PUBLIC VISUAL STRUCTURAL FUNCTIONS: Functions that affect the visuals and structure of the MC 
	//************************************************************
	public function disableAcceptDeny(){
	
		txtQuestionsRound2.t.enabled = false;
		txtQuestionsRound2.f.enabled = false;
		
	}

	
	public function enableAcceptDeny(){
	
		txtQuestionsRound2.t.enabled = true;
		txtQuestionsRound2.f.enabled = true;
		
	}
	
	
	public function disableContinue(){
	
		txtAnswersRound2.c.enabled = false;
		
	}

	
	public function enableContinue(){
	
		txtAnswersRound2.c.enabled = true;
		
	}
	
	public function enable(){
		
		
	}
	
	public function disable(){
		
		
	}
	
	
	public function v_hide(){
		
		_visible = false;
		
	}
	
	
	public function v_show(){
		
		_visible = true;
		
	}

	//************************************************************
	//PRIVATE VISUAL STRUCTURAL FUNCTIONS: Functions that affect the visuals and structure of the MC 
	//************************************************************
	
	/*private function v_function(){
		
		
		
	}*/
	
	//************************************************************
	//PUBLIC CHARACTER FUNCTIONS: Functions that animate characters
	//************************************************************
	
	//************************************************************
	//PUBLIC CHARACTER SCRIPT FUNCTIONS: Functions called from outside which execute character animation scripts
	//************************************************************
	
	//************************************************************
	//PUBLIC GENERAL FUNCTIONS
	//************************************************************
	
	//************************************************************
	//PRIVATE GENERAL FUNCTIONS
	//************************************************************
	
	//************************************************************
	//PRIVATE HELPER FUNCTIONS
	//************************************************************

	//____EVENTS_________________________________________________

	//************************************************************
	//REGULAR EVENT FUNCTIONS: Functions that fire off regular MC events like private function onRelease(){}
	//************************************************************

	//************************************************************
	//CUSTOM EVENT FUNCTIONS: Functions that fire off custom made dispatched events
	//************************************************************
	
	//************************************************************
	//CUSTOM LOCAL EVENT FUNCTIONS: Functions that fire off events written into the fla of a MC like _parent.e_fireMyFunction();
	//************************************************************
	
	private function e_true(){
		
		trace("TRUE");
		v_showAnswer("true");
		
	}
	
	private function e_false(){
		
		trace("FALSE");
		v_showAnswer("false");
		
	}
	
	private function e_continue(){
		
		disableContinue();
		//var myTween:Object = new Tween(this, "_alpha", Regular.easeOut, 100, 0, .5, true);
			//pause code
		var myFunc = function(callingMC:MovieClip){
				
			var myTween:Object = new Tween(callingMC, "_alpha", Regular.easeOut, 100, 0, .5, true);
									
		};
		pauseCodeAndCallFunction(1, myFunc);
		
		//the user has answered two questions incorrectly
		if(getRef().ScoreMissesRound2 >= 2){
			
			
			//pause code
			var myFunc = function(callingMC:MovieClip){
									
				callingMC.dispatchMyEvent("e_UserLooses", {myMessage:"none"});
									
			};
						
			pauseCodeAndCallFunction(2, myFunc);
			return;
			
		}
		
		
		if(__questionNo != 3){
			
			_level0.jdgSoundHandMC.fadeSounds('in');
			
			//pause code
			var myFunc = function(callingMC:MovieClip){
									
				callingMC.v_askQuestion();
									
			};
						
			pauseCodeAndCallFunction(2, myFunc);
			
		}else{
			
			//pause code
			var myFunc = function(callingMC:MovieClip){
									
				callingMC.dispatchMyEvent("e_TFQuestionsFinished", {myMessage:"none"});
									
			};
						
			pauseCodeAndCallFunction(2, myFunc);
			
		}
	}
	
	//************************************************************
	//SUB MCs THAT FIRE FUNCTIONS: Functions that are called from .as files child MovieClips
	//************************************************************
	

}
